unit Unit2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, ppComm, ppRelatv, ppProd,
  ppClass, ppReport, ppCtrls, ppVar, ppPrnabl, ppBands, ppCache, ppDesignLayer,
  ppParameter, Vcl.Imaging.pngimage, Vcl.ExtCtrls, ppSMTPOutlook, ppRESTMailGmail, ppRESTMailOutlook365;

type
  TForm2 = class(TForm)
    ppReport1: TppReport;
    Button1: TButton;
    cbxSMTP: TCheckBox;
    cbxGmail: TCheckBox;
    cbxOutlook: TCheckBox;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    ppParameterList1: TppParameterList;
    ppDesignLayers1: TppDesignLayers;
    ppDesignLayer1: TppDesignLayer;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    ppLabel1: TppLabel;
    ppSystemVariable1: TppSystemVariable;
    ppLabel2: TppLabel;
    ppLabel3: TppLabel;
    ppLabel4: TppLabel;
    ppImage1: TppImage;
    procedure Button1Click(Sender: TObject);
  private
    procedure SetupPlugins;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses
  ppSMTPCustom;

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
begin
  SetupPlugins;

  ppReport1.EmailSettings.Enabled := cbxSMTP.Checked or cbxGmail.Checked or cbxOutlook.Checked;
  ppReport1.EmailSettings.ConnectionSettings.EnableMultiPlugin := True;

  ppReport1.Print;

end;

procedure TForm2.SetupPlugins;
begin
  //Register or unregister plugins based on selection

  //SMTP - Only one SMTP plugin can be registered at a time
  if cbxSMTP.Checked then
    TppSMTPPlugin.RegisterClass(TppSMTPOutlook)
  else
    TppSMTPPlugin.UnRegisterClass(TppSMTPOutlook);

  //Cloud Mail - Multiple REST Mail services can be registered at a time
  //Gmail
  if cbxGmail.Checked then
    TppSMTPPlugin.RegisterClass(TppRESTMailGmail)
  else
    TppSMTPPlugin.UnRegisterClass(TppRESTMailGmail);

  //Add proper credentials to access Gmail REST API
  ppReport1.EmailSettings.ConnectionSettings.WebMail.GmailSettings.OAuth2.ClientID := '***';
  ppReport1.EmailSettings.ConnectionSettings.WebMail.GmailSettings.OAuth2.ClientSecret := '***';
  ppReport1.EmailSettings.ConnectionSettings.WebMail.GmailSettings.OAuth2.RedirectURI := 'http://localhost';

  //Outlook.com
  if cbxOutlook.Checked then
    TppSMTPPlugin.RegisterClass(TppRESTMailOutlook365)
  else
    TppSMTPPlugin.UnRegisterClass(TppRESTMailOutlook365);

  //Add proper credentials to access Outlook.com REST API
  ppReport1.EmailSettings.ConnectionSettings.WebMail.Outlook365Settings.OAuth2.ClientID := '***';
  ppReport1.EmailSettings.ConnectionSettings.WebMail.Outlook365Settings.OAuth2.ClientSecret := '***';
  ppReport1.EmailSettings.ConnectionSettings.WebMail.Outlook365Settings.OAuth2.RedirectURI := 'http://localhost';

end;

end.
